#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
int zeSouboru()
{
    FILE *fr;
    char nazev[30], prip[4], vstup[34];
    int k;
    printf("Zadej jmeno souboru bez pripony: ");
    scanf("%29s",nazev);
    printf("Zadej priponu: ");
    scanf("%3s",prip);
    sprintf(vstup,"%s.%s",nazev,prip);
    printf("\nNazev souboru s priponou je: %s\n",vstup);
    if((fr=fopen(vstup,"r"))==NULL)
    {
        printf("Soubor %s nelze otevrit\n",vstup);
        exit(-1);
    }
    fscanf(fr,"%d",&k);
    if((fclose(fr))==EOF)
    {
        printf("Soubor %s nelze uzavrit\n",vstup);
        exit(-1);
    }
    return(k);
}
double **vyroba2Dpole(int r, int s)
{
    double **pX;
    int i;
    pX=(double **)malloc(r*sizeof(double *));
    for(i=0; i<r; i++)
        pX[i]=(double *)malloc(s*sizeof(double));
    return(pX);
}
void uvolni(double **pX, int r, int s)
{
    int i;
    for(i=0; i<r; i++)
        free((void *)pX[i]);
    free((void **)pX);
}
void doSouboru(double **pX, int r, int s, int k)
{
    FILE *fw;
    char nazev[30], vystup[34], radka[100];
    int i,j,q;
    printf("Zadej jmeno souboru bez pripony: ");
    scanf("%29s",nazev);
    sprintf(vystup,"%s.csv",nazev);
    printf("\nUklada se do souboru %s\n",vystup);
    if((fw=fopen(vystup,"w"))==NULL)
    {
        printf("Soubor %s nelze otevrit",vystup);
        exit(-1);
    }
    q=0;
    for(i=0; i<360; i+=k)
    {
        pX[q][0]=(double)i;
        pX[q][1]=sin(pX[q][0]*M_PI/180);
        if(i!=0)
        {
            pX[q][2]=log(pX[q][0]);
            sprintf(radka,"%5.0f;%10.4f;%10.4f;\n",pX[q][0],pX[q][1],pX[q][2]);
        }
        else
            sprintf(radka,"%5.0f;%10.4f;%10c;\n",pX[q][0],pX[q][1],'-');
        printf("%s",radka);
        j=0;
        while(radka[j]!='\0')
        {
            if(radka[j]=='.')
                radka[j]=',';
            j++;
        }
        fprintf(fw,"%s",radka);
        q++;
    }
    if(fclose(fw)==EOF)
    {
        printf("Soubor %s nelze uzavrit",vystup);
        exit(-1);
    }
}
int main()
{
    int k,r,s;
    k=zeSouboru();
    r=360/k+1;
    s=3;
    double **pA;
    printf("\nKrok je %d\n",k);
    pA=vyroba2Dpole(r,s);
    doSouboru(pA,r,s,k);
    uvolni(pA,r,s);
    return 0;
}

